/*1.Klasy zawierajace skladowe typu jednowymiarowa tablica elementow
    typu int
  2.Przeciazanie operatorow - definicje za pomoca funkcji skladowych
  3.Obiekty typu const, metody typu const.

 Zmien definicje pol x, y klasy punkt na tablice elementow typu integer.
 Konstruktor domniemany okresla liczbe wsporzednych (mozliwe 3)
 - domniemana liczba wspolrzednych rowna 2.
 Klasa punkt powinna posiadac przeciazone operatory jako skladowe
 klasy punkt oraz metody realizujace te same funkcje niektorych
 operatorow. Metody te powinny byc typu const wszedzie tam, gdzie
 to mozliwe:
 1) dwa operatory indeksowania - jeden do zapisu danych, drugi do
    czytania tablicy umieszczonej w klasie. Zastosuj slowo const
 2) operator -(podanie odleglosci miedzy punktami - lewym i prawym
    argumentem-obiektem; operator zwraca wartosc float),
 3) funkcja skladowa odleglosc realizujaca czynnosci operatora -
 4) operator + (zwraca wypadkowy obiekt typu punkt o wspolrzednych
    stanowiacych sume wspolrzednych lewego i prawego argumentu -
    obiektu)
 5) operatory == oraz != tak, aby mozna bylo ich uzywac do sprawdzenia,
    ktore argumenty-obiekty maja wspolrzedne wieksze lub rowne
 6) operator * (wartosc float, stanowiaca wynik mnozenia wspolrzednych
    punktow czyli prawego i lewego argumentu-obiektu).

 Wykonaj:
1. Zabezpiecz pliki zrodlowe punkt3_c.h z deklaracja klasy punkt
   przed wystapieniem wielokrotnej deklaracji.
2. Uzupelnij plik zrodlowy punkt3_c.cpp zawierajacy definicje
   metod klasy punkt
3. Wykonaj projekt zawierajacy pliki:punkt3_c.cpp oraz lab3_c.cpp.
   Po kompilacji program powinien dzialac jak program lab3_c.exe.

Pytania kontrolne:
1. Podaj zasady okreslajace przeciazanie operatorow jako funkcji
   skladowych.
2. Wyjasnij, dlaczego udalo sie przeciazyc dwa operatory indeksowania?
3. Dlaczego obiekt p3 nie zmienia swojej zawartosci po wywolaniu funkcji
   zmien ?
4. Czy metoda przesun moze byc typu const -wyjasnij?
*/

#include <stdio.h>
#include <iostream.h>
#include <conio.h>
#include "punkt3_c.h"
void wyswietl(const punkt& p);
void zmien(punkt& p);

void main()
 {
  clrscr();
  punkt p1, p2 (3);
  const punkt p3(2);
  zmien(p1); // wywolana funkcja wykonaj ze zwyklym parametrem punkt&
  wyswietl(p1);
  zmien(p2); // wywolana funkcja wykonaj ze zwyklym parametrem punkt&
  wyswietl(p2);
  zmien(p3); // wywolana funkcja wykonaj z parametrem const punkt&
          //dane nie beda zapisane do p3-ostrzezenie ze strony kompilatora
  wyswietl(p3);
  punkt p4 = p1;//tyle wspolrzednych w p4, ile w p1
  wyswietl(p4);
        //operator przeciazony -
  cout << "\np1 - p2: " << (p1 - p2)
  <<", p1.operator-(p2): "<<p1.operator-(p2);
  cout << "; p1.odleglosc(p2): " << p1.odleglosc(p2) <<'\n';
        //operator przeciazony +
  punkt p5=p1+p2;
  cout << "punkt p5=p1+p2; ";
  wyswietl(p5);
        //operator przeciazony ==
  cout<< "p1==p2: "<<(p1 == p2)
  <<", p1.operator==(p2): "<<p1.operator==(p2);
        //operator przeciazony !=
  cout << "\np1!=p2: " << (p1 != p2)
  <<", p1.operator!=(p2): "<<p1.operator!=(p2);
        //operator przeciazony *
  cout << "\np1 * p2: " << (p1 * p2)
  <<", p1.operator*(p2): "<<p1.operator*(p2)<<'\n';
   getch();
 }

//uniwersalny sposob przekazywania parametrow dla obiektow typu const
// i zwyklych przeznaczonych do odczytu

void wyswietl(const punkt& p)
{//wywolany operator indeksowania z const
  int j = p.p_ile();
  for (int i=0;i<j;i++)
    cout <<"Wspolrzedna " << i <<" = "<< p[i] << ", ";
  cout <<'\n';
}

// tylko dla zwyklych obiektow kompilator nie zglasza ostrzezen

void zmien(punkt& p)
{// wywolany operator indeksowania bez const
 int j= p.p_ile();
 cout<<"Podaj wspolrzedne punktu o "<<j<<" wspolrzednych"<<'\n';
 for (int i=0;i<j;i++)
  { cout <<"Wspolrzedna " << i <<" : ";
    cin >> p[i];
  }
 }


