/*1. Przeciazanie konstruktora: bez parametrow i z parametrami
  2. Przeciazanie metody odleglosc przez przekazywanie obiektow przez:
     wartosc, referencje, wskaznik. Parametry przekazywane nie sa
     chronione hermetyzacja (specyfikator private).

  Zrealizowac klase punkt do obslugi punktow na plaszczyznie.
  Klasa ta oprocz metod z lab1_6 posiada:
  * dwa konstruktory przeciazone: jeden z parametrami i drugi
    bez parametrow, pelniacy role konstruktora domyslnego
  * trzy metody  odleglosc, przeciazone za pomoca typow
    parametrow naglowka: punkt jest przekazany prze referencje,
    wskaznik oraz wartosc (w tym przypadku w celu przeciazenia
    dodano fikcyjny parametr int).
    W metodach do skladowych pol przekazywanych punktow mozna
    wyjatkowo odwolac sie bezposrednio do pol (np p.x, p->x).

  Zobacz, jak dziala program lab2_a.exe.
  Napisac oddzielnie plik zrodlowy punkt2_a.h z deklaracja klasy,
  plik modulowy punkt2_a.cpp zawierajacy jej definicje. Wykonaj
  projekt laczacy plik programu lab2_a.cpp oraz plik modulowy.
  program wykorzystujacy te klase lab2_a.cpp. Zastosowac dyrektywy
  uniemozliwiajace ponowna kompilacje pliku naglowkowego.
 
  Pytania kontrolne:
1. Dlaczego zastosowano parametr fikcyjny w naglowku metody odlegosc
2. Przekazujacej parametr typu punkt przez wartosc?
3. Dlaczego w programie wyznaczana jest nieprawidlowa liczba obiektow?
4. Wyjasnij mechanizm przeciazania funkcji wyswietl, metod odlegosc
   oraz konstruktorow?
*/

#include <iostream.h>
#include "punkt2_a.h"
#include <conio.h>
void wyswietl(punkt*);
void wyswietl(float);
void wyswietl(int);
void main()
{ clrscr();
 { wyswietl(punkt::liczba_punktow());
   punkt p1(1, 2), p2(2, 3);       //konstruktor x2 z jawnie podanymi paramterami
   wyswietl(&p1); wyswietl(&p2);     //p1 i p2 przekazany przez wskaznik
   wyswietl(punkt::liczba_punktow());

   wyswietl(p1.odleglosc(&p2));           //p2 przekazane prze wskaznik
   wyswietl(p2.odleglosc(&p1));           //p1 przekazane prze wskaznik
   wyswietl(p1.odleglosc(p2));            //p2 przekazane przez referencje
   wyswietl(p2.odleglosc(p1));            //p1 przekazane przez referencje
   wyswietl(punkt::liczba_punktow());
   getch();
   wyswietl(p2.odleglosc(p1,2));          //p1 przekazane przez wartosc
   wyswietl(punkt::liczba_punktow());
   wyswietl(p1.odleglosc(p2,2));          //p2 przekazane przez wartosc
   wyswietl(punkt::liczba_punktow());
   getch();
 } //tutaj koniec bloku i zostaja usuniete wszystkie obiekty powowlane
  //w poprzednim bloku
 {
   wyswietl(punkt::liczba_punktow());
   punkt p1, p2;        //konstruktor x2 z domniemanymi wartosciami parametrow
   wyswietl(p1.liczba_punktow());
   wyswietl(&p1); wyswietl(&p2);        //p1 i p2 przekazany przez wskaznik
   wyswietl(punkt::liczba_punktow());
 } //tutaj koniec bloku i zostaja usuniete wszystkie obiekty powowlane
  //w poprzednim bloku
 wyswietl(punkt::liczba_punktow());
}

void wyswietl(punkt *p)
{
 cout <<"Wspolrzedne: " << p->odcieta() << " "<< p->rzedna() << '\n';
}

void wyswietl(float w)
{
 cout <<"Odleglosc: " << w << '\n';
}

void wyswietl(int w)
{
 cout <<"Liczba punktow: " << w << '\n';getch();
}