/*1. Zwracanie wyniku dzialania funkcji przez wartosc, referencje, 
     wskaznik. Autoreferncja - wskaznik do obiektu this.
  2. Konstruktor z parametrami domniemanymi zastepujacy konstruktory
     przeciazone z parametrami i domyslny bez parametrow

 Zrealizowac klase punkt do obslugi punktow na plaszczyznie. Klasa ta
 spelnia warunki zadania lab2_a oraz powinna
 * posiadac trzy metody o nazwie skrajny przekazujace i zwracajace
   wynik funkcji przez punkt odpowiednio przez wartosc, referencje
   oraz wskaznik. Metody te jako wynik zwracaja punkt wywolujacy (*this)
   metode, jesli jedna z jego wspolrzednych jest wieksza lub
   rowna wspolrzednym obiektu przekazanego do metody, w przeciwnym 
   wypadku zwracany jest punkt przekazany do funkcji.
 * metode suma zwracajacy przez wartosc obiekt typu punkt zawierajcy
   wspolrzedne jako suma wspolrzednych obiektu wywolujacego metode
   oraz obiektu przekazanego do metody.
 * metody pozwalajace zmienic wartosci wspolrzednych x i y punktu

 Zobacz, jak dziala program lab2_b.exe.
 Napisac oddzielnie plik zrodlowy punkt2_b.h z deklaracja klasy,
 plik zrodlowy punkt2_b.cpp zawierajacy jej definicje. Wykonaj
 projekt laczacy plik programu lab2_b.cpp oraz plik modulowy.
 Zastosowac dyrektywy uniemozliwiajace ponowna kompilacje pliku 
 naglowkowego.

  Pytania kontrolne:
1.  Dlaczego w programie zle wyznacza sie liczbe obiektow?
2.  Przedstaw przebieg wywolania metody skrajny (kiedy i jakie 
    konstruktory oraz destruktor)?
3.  Kiedy wywolywany jest w programie konstruktor z parametrami 
    domniemanymi, a kiedy z jawnie podanymi parametrami?
*/

#include <iostream.h>
#include "punkt2_b.h"
#include <conio.h>
void wyswietl(punkt*);
void wyswietl(float);
void wyswietl(int);

void main()
{ clrscr();
 { wyswietl(punkt::liczba_punktow());
   punkt p1(2, 3), p2(1, 2);
   wyswietl(&p1); wyswietl(&p2);
   wyswietl(punkt::liczba_punktow());
   punkt &p3=p1.skrajny(p2);      //przez referencje argument i wynik metody
   wyswietl(&p3);
   wyswietl(punkt::liczba_punktow());
   punkt* p4=p1.skrajny(&p2);      //przez wskaznik argument i wynik metody
   wyswietl(p4);
   wyswietl(punkt::liczba_punktow());
   punkt p5=p1.skrajny(p2,1);       //przez wartosc argument i wynik metody
   wyswietl(&p5);
   wyswietl(punkt::liczba_punktow());
   punkt p6=p5.suma(p1);        //parametr prze referencje, wynik przez wartosc
   wyswietl(&p6);
   wyswietl(punkt::liczba_punktow());
 } //tutaj koniec bloku i zostaja usuniete wszystkie obiekty powowlane
  //w poprzednim bloku
 {
   wyswietl(punkt::liczba_punktow());
   punkt p1, p2;
   wyswietl(&p1); wyswietl(&p2);
   wyswietl(punkt::liczba_punktow());
 } //tutaj koniec bloku i zostaja usuniete wszystkie obiekty powowlane
  //w poprzednim bloku
   wyswietl(punkt::liczba_punktow());
 }

void wyswietl(punkt *p)
{
 cout <<"Wspolrzedne: " << p->odcieta() << " "<< p->rzedna() << '\n';
}

void wyswietl(float w)
{
 cout <<"Odleglosc: " << w << '\n';
}

void wyswietl(int w)
{
 cout <<"Liczba punktow: " << w << '\n';getch();
}