/*1. Jawny konstruktor kopiowania
  2. Zastosowanie funkcji z lewej strony operatora przypisania -
     funkcje zwracaja obiektowy wynik dzialania przez referencje,
     wskaznik i wartosc.
Uwaga: plik programu lab2_72 wymaga tych samych plikow
       naglowkowego i modulowego, co program lab2_71

 Zobacz, jak dziala program lab2_72.exe.
 Napisac oddzielnie plik zrodlowy punkt2_6.h z deklaracja klasy,
 plik zrodlowy punkt2_6.cpp zawierajacy jej definicje. Wykonaj
 projekt laczacy plik modulowy oraz program wykorzystujacy te 
 klase lab2_6.cpp. Zastosowac dyrektywy uniemozliwiajace ponowna 
 kompilacje pliku naglowkowego.

 Pytanie kontrolne
1. Przeanalizuj zastosowanie odpowiednio z lewej strony przypisania
   przeciazonych funkcji skladowych skrajny i umieszczenie z prawej
   strony obiektow tymczasowych typu punkt utworzonych z wywolaniem
   konstruktora z parametrami. 
2. Dlaczego teraz prawidlowo obliczana jest liczba obiektow? */

#include <iostream.h>
#include "punkt2_6.h"
#include <conio.h>
void wyswietl(punkt&);
void wyswietl(float);
void wyswietl(int);
void main()
{ clrscr();
 { wyswietl(punkt::liczba_punktow());
   punkt p1(2, 2), p2(1, 5);
   wyswietl(punkt::liczba_punktow());
   wyswietl(p1);
   wyswietl(p2);

 //zwrananie  obiektowego wyniku metody przez referencje
   punkt& p3=p1.skrajny(p2);      //wynik metody i argument przez referencje
   wyswietl(p3);             //obiekt p3 jest referencyjny dla obiektu p1

//funkcja zwracajaca wynik przez referencje z lewej strony operatora przypisania
  p1.skrajny(p2)=punkt(8,8);
  wyswietl(p1);                                          //p1.x=8, p1.y=8
  p2.skrajny(p1)=punkt(2,6);
  wyswietl(p1);                                          //p1.x=2. p1.y=6

 //zwracanie obiektowego  wyniku metody przez wskaznik
   punkt* p4=p1.skrajny(&p2);       //wynik metody i argument przez wskaznik
   wyswietl(*p4);                //wskaznik p4 zawiera adres obiektu p1 (2, 6)

//funkcja zwracajaca wynik przez wskaznik z lewej strony operatora przypisania
  *p1.skrajny(&p2)=punkt(8,8);
  wyswietl(p1);                                              //p1.x=8, p1.y=8

  *p2.skrajny(&p1)=punkt(3,7);
  wyswietl(p1);                                             //p1.x=3. p1.y=7

 //zwracanie obiektowego wyniku funkcji przez wartosc
   punkt& p5=p1.skrajny(p2,0);          //wynik metody i argument przez wartosc
   wyswietl(p5);
   wyswietl(punkt::liczba_punktow());
//funkcja zwracajaca wynik przez wartosc z lewej strony operatora przypisania
   wyswietl(p1.skrajny(p2,0)=punkt(8,8));
   wyswietl(p1);//p1.x=3, p1.y=7
   wyswietl(p2.skrajny(p1,0)=punkt(1,1));
   wyswietl(p1);//p1.x=3, p1.y=7

   wyswietl(punkt::liczba_punktow());
 } //tutaj koniec bloku i zostaja usuniete wszystkie obiekty powowlane
   //w poprzednim bloku
   wyswietl(punkt::liczba_punktow());
 }

void wyswietl(punkt& p)
{
 cout <<"Moje wspolrzedne: " << p.odcieta() << " "<< p.rzedna() << "\n";
 getch();
}

void wyswietl(float w)
{
 cout <<"Odleglosc: " << w << '\n';
}

void wyswietl(int w)
{
 cout <<"Liczba punktow: " << w << '\n';
 getch();
}