/*1.Tworzenie obiektow posiadajacych obiekty skladowe
  2.Funkcja zaprzyjazniona z dwiema klasami

 Zrealizowac klase kolo do obslugi kol na plaszczyznie zawierajaca
 skladowa obiektowa punkt przechowujacy wspolrzedne srodka kola.
 Klasa punkt spelnia warunki zadania lab2_c, posiada statyczna metode
 info zwracajaca numer klasy oraz zaprzyjazniona funkcje wyswietl
 razem z klasa kolo. Klasa kolo zawiera:
 * pole statyczne i metode statyczna do zliczania liczby kol
 * metode statycza info zwracajaca numer klasy kolo
 * metode obliczajaca odleglosc miedzy srodkami kol - kola wywolujcego
   metode oraz przekazanego przez referencje do metody. Metoda korzysta
   z metody odleglosc z klasy punkt.
 * metody zwracajace pola klasy: promien typu float oraz
   srodek typu punkt
 * konstruktor zwykly z parametrami domniemanymi liczacy obiekty typu
   kolo
 * konstruktor kopiujacy oraz destruktor aktualizujace miedzy innymi
   liczbe obiektow typu kolo.
 * metode zaprzyjazniona z klasa kolo i punkt wyswietl do wyswietlenia
   danych kola: promienia oraz wspolrzednych srodka bez zachowania
   hermetyzacji

Zobacz, jak dziala program lab3_a.exe.
Wykonaj:
1. Zabezpiecz pliki zrodlowe punkt3_a.h z deklaracja klasy punkt oraz
   kolo3_a.h z deklaracja klasy kolo przed wystapieniem wielokrotnej
   deklaracji.
2. Uzupelnij plik zrodlowy punkt3_a.cpp zawierajacy definicje klasy
   punkt (kod zrodlowy tego pliku jest identyczny jak punkt2_6.cpp
   oprocz instrukcji dolaczenia pliku naglowkowego) oraz plik zrodlowy
   kolo3_a.h z definicja klasy kolo.
3. Wykonaj projekt zawierajacy pliki: punkt3_a.cpp, kolo3_a.cpp
   oraz lab3_a.cpp. Po kompilacji program powinien dzialac
   jak program lab3_a.exe.

Pytania kontrolne:
1. Podaj zasady okreslajace, ktore i w jakiej kolejnosci wywolywane sa
   konstruktory i destruktory. Co nalezy zrobic, aby zostal wywolany
   konstruktor kopiujacy punktu, gdy wywolany jest konstruktor
   kopiujacy kola? (linia//1 programu)
2. Dlaczego funkcja wyswietl moze bezposrednio odwolac sie do pol
   obiektow klasy punkt oraz kolo? Co nalezalo zrobic?
3. Czy klasa kolo moze odwolac sie do skladowych prywatnych klasy
   punkt?
*/

#include <iostream.h>
#include "kolo3_a.h"
#include "punkt3_a.h"

#include <conio.h>
void wyswietl(float);
void wyswietl(int,int);
void main()
{ clrscr();
 { wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   kolo p1(2,2,3), p2(1,5,6);
   wyswietl(p1); wyswietl(p2);
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   getch();
   kolo p3 = 2;
   wyswietl(p3);
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   getch();
   kolo p4 = p1;					//1
   wyswietl(p4);
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   getch();
   kolo p5 = kolo (5,5,5);
   wyswietl(p5);
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   getch();
   p4 = kolo (6,6,6);
   wyswietl(p4);
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   getch();
   kolo p6;
   wyswietl(p6);
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   getch();
 }
  wyswietl(kolo::liczba_kol(),kolo::info());
  wyswietl(punkt::liczba_punktow(),punkt::info());
  getch();
 }

void wyswietl(float w)
{
 cout <<"Odleglosc: " << w << '\n';
}

void wyswietl(int w,int nr)
{
 cout <<"Liczba obiektow: " << w << " o numerze "<< nr <<'\n';
}