/*1.Klasy zawierajace skladowe typu dynamiczna jednowymiarowa tablica
    elementow	typu int
  2.Przeciazanie operatorow - definicje za pomoca funkcji zaprzyjaznionych.
  3.Obiekty typu const, metody typu const.

 Zmien definicje pol x, y klasy punkt na dynamiczna tablice elementow
 typu integer.
 Konstruktor domniemany okresla liczbe wsporzednych (mozliwe 3)
 - domniemana liczba wspolrzednych rowna 2.
 Klasa punkt powinna posiadac konstruktor zwykly i kopiujacy, ktore
 tworza dynamiczna tablice wsp na zadana liczbe wspolrzednych, natomiast
 destruktor powinien usuwac ja ze sterty.
 Klasa punkt powinna posiadac przeciazone operatory jako zaprzyjaznione
 funkcje klasy punkt oraz zwykle funkcje zaprzyjaznione realizujace te
 same funkcje niektorych operatorow. Funkcje te powinny byc typu const
 wszedzie tam, gdzie
 to mozliwe:
 1) dwa operatory indeksowania - jeden do zapisu danych, drugi do
    czytania tablicy umieszczonej w klasie. Zastosuj slowo const
 2) operator -(podanie odleglosci miedzy punktami - lewym i prawym
    argumentem-obiektem; operator zwraca wartosc float),
 3) funkcja odleglosc realizujaca czynnosci operatora -
 4) operator + (zwraca wypadkowy obiekt typu punkt o wspolrzednych
    stanowiacych sume wspolrzednych lewego i prawego argumentu - 
    obiektu)
 5) operatory == oraz != tak, aby mozna bylo ich uzywac do sprawdzenia,
    ktore argumenty-obiekty maja wspolrzedne wieksze lub rowne
 6) operator * ( wartosc float, stanowiaca wynik mnozenia wspolrzednych
    punktow czyli prawego i lewego argumentu-obiektu).
 7) operator << zastepujacy funkcje niezalezna wyswietl(punkt&)
    z lab3_c tzn. przeciazony na rzecz obiektow klasy punkt
 8) operator >> zastepujacy funkcje niezalezna zmien(punkt&) z lab3_c
    tzn. przeciazony na rzecz obiektow klasy punkt

 Wykonaj:
1. Zabezpiecz pliki zrodlowe punkt3_d.h z deklaracja klasy punkt
   przed wystapieniem wielokrotnej deklaracji.
2. Uzupelnij plik zrodlowy punkt3_d.cpp zawierajacy definicje
   metod i funkcji zaprzyjaznionych klasy punkt
3. Wykonaj projekt zawierajacy pliki: punkt3_d.cpp oraz lab3_d.cpp.
   Po kompilacji program powinien dzialac jak program lab3_d.exe.

 Pytania kontrolne:
1. Jakie wlasnosci posiadaja funkcje zaprzyjaznione z klasa?
2. Podaj zasady okreslajace przeciazanie operatorow jako funkcji
   zaprzyjaznionych. Dlaczego operatory << dla standardowego wyjscia
   oraz >> dla standardowego wejscia nie moga byc funkcjami skladowymi?
3. Dlaczego obiekt p3 nie zmienia swojej zawartosci po wywolaniu
   operatora >>?
 
*/

#include <iostream.h>
#include <conio.h>
#include "punkt3_d.h"
void main()
 {
   clrscr();
   punkt p1, p2(4);
   const punkt p3(2);
      //operator przeciazony >> tylko jako funkcja zaprzyjazniona
   cin>>p1;
      //operator przeciazony >> tylko jako funkcja zaprzyjazniona
   operator>>(cin, p2);
   cin>>p3;  //ostrzezenie ze strony kompilatora-wywolanie operatora
	     //ktory probuje zmienic zawartosc przekazywanego obiektu typu const;
	    //dane nie beda zapisane do obiektu p3!
       //operator przeciazony << tylko jako funkcja zaprzyjazniona
   cout<<(p3);
       //operator przeciazony << tylko jako funkcja zaprzyjazniona
   operator<<(cout,p1);
   cout<<p2;
   punkt p4 =p2;
   cout<<p4;
       //funkcja zaprzyjazniona jako operator przeciazony -
   cout << "\np1 - p2: " << (p1 - p2)
   <<", operator-(p1,p2): "<<operator-(p1,p2);
       //funkcja zaprzyjazniona odleglosc
   cout << "; odleglosc(p1,p2): " << odleglosc(p1,p2)<<'\n';
       //funkcja zaprzyjazniona jako operator przeciazony+
   punkt p5=p1+p2;                  //operator+(p1,p2)
   cout << "punkt p5=p1+p2, ";
   cout<<p5<<'\n';
       //funkcja zaprzyjazniona jako operator przeciazony *
   cout << "\np1 * p2: " << (p1 * p2)
   <<", operator*(p1,p2): "<<operator*(p1,p2);
       //funkcja zaprzyjazniona jako operator przeciazony ==
   cout << "\np1==p2: " << (p1 == p2)
   <<", operator==(p1,p2): "<<operator==(p1,p2);
       //funkcja zaprzyjazniona jako operator przeciazony !=
   cout << "\np1!=p2: " << ( p1!= (p2))
   <<", operator!=(p1,p2): "<< operator!=(p1,p2)<<'\n';
   getch();
 }
