/* Klasa zawierajaca dynamiczna tablice struktur: przeciazanie
   operatorow indeksowania [] oraz >> i <<.

 Obiekt typu figura powinien zawierac:
 * konstruktor zwykly tworzacy dynamiczna tablice struktur
   zawierajacych wspolrzedne punktow (x,y); konstruktor kopiujacy
   tworzacy dynamiczna tablice struktur i kopiujacy zawartosc
   przekazywanego obiektu oraz destruktor usuwajacy te
   tablice za pomoca delete
 * metode rysuj, wyswietlajace znak  na ekranie w miejscu (x,y),
   wtedy gdy (x,y) mieszcza sie na ekranie (x=1/80,y=1/25)
 * metode przesun, zmieniajaca wspolrzedne x o dx i y o dy.
 * dwa przeciazone operatory indeksowania: jeden do czytania i drugi
   do zapisu wartosci x i y wybranego i-tego punktu z tablicy
 * operator przeciazony >> (lewy argument: obiekt klasy istream,
   prawy argument: struktura wsp - wpisywanie danych do tablicy Figura
 * operator przeciazony << (lewy argument: obiekt klasy ostream,
   prawy argument: struktura wsp - czytanie danych z tablicy Figura

 Wykonac:
 1.Sprawdz dzialanie programu lab4_b.exe
 2.Dokonaj analizy programu lab4_b.cpp, wprowadzajacego wspolrzedne
   wierzcholkow wielokata o maksymalnej liczbie okreslonej
   liczba max i wyswietlajacego wspolrzedne na ekranie.
 3.Wykonaj plik modulowy fig4_b.cpp zawierajacy definicje skladowych
   klasy figura. Nalezy zabezpieczyc metody przed czytaniem
   elementow tablicy Figura poza jej ograniczajacymi indeksami 0-max.
 4.Zastosuj dyrektywy uniemozliwiajace ponowna kompilacje
   pliku naglowkowego fig4_b.h. Wykonaj projekt laczacy pliki
   lab4_b.cpp oraz fig4_b.cpp.

 Pytania kontrolne:
 1. Co umozliwia przeciazenie dwoch operatorow indeksowania?
 2. Co powoduje prawidlowe wywolanie operatorow indeksowania
    w funkcjach wprowadz_punkty i wyswietl?
 3. Scharakteryzuj zastosowanie const w metodach klasy figura
   i przy przekazaniu parametrow (funkcja wyswietl)*/

#include <iostream.h>
#include <iomanip.h> 										//manipulator setw()
#include <conio.h>
#include "fig4_b.h"
 void wprowadz_punkty(figura&);
 void wyswietl(const figura);
 void main()
 { clrscr();
   do
   {
    figura wielokat(5);
    cout<<"Nalezy wprowadzic wspolrzedne (a,b) pieciu roznych punktow\n";
    getch();
    clrscr();			//niezalezna funkcja, gdyz figura nie
    wprowadz_punkty(wielokat);  //powinna wprowadzac danych
    wielokat.rysuj();  		//obiekt sam rysuje sie
		getch();
    clrscr();
    wyswietl(wielokat); //niezalezna funkcja, gdyz figura nie musi
     //wyswietlac wartosci swoich wspolrzednych
    cout<<" Jesli koniec, nacisnil ESC, dalej - dowolny klawisz\n";
   }while (getch() != 27);
 }

 void wprowadz_punkty(figura& wielokat)
  {
   int ile = wielokat.podaj_wsp();
   for (int i = 0; i < ile; i++)
    {
     cout<< "Podaj wspolrzedne x, y dla wielokat["<<i<<"]: ";
     cin >> wielokat[i];
     clrscr();
    }
 }

 void wyswietl(const figura wielokat)
 {
   getch();
   int ile = wielokat.podaj_wsp();
   clrscr();
   for (int i=0;i<ile;i++)
     cout<< setw(15)<<"Wielokat["<<i<<"] "<<
            setw(5)<<wielokat[i]<<endl;
  }
